;**********************************************************************;
;*                 A T O M I C   D E B U G G E R                      *;
;*--------------------------------------------------------------------*;
;*    doel           : machinetaal debugger voor Atom-in-PC met       *;
;*                     ondersteuning van 6502, 65C02 en 65802         *;
;*--------------------------------------------------------------------*;
;*    filenaam       : options.inc                                    *;
;*    auteur         : Roland Leurs                                   *;
;*                     The Atomic Development Studio                  *;
;*    ontwikkeld     : maart 1998                                     *;
;*    laatste update :                                                *;
;*--------------------------------------------------------------------*;
;*    assembleren    : x6502 DEBUG                                    *;
;*--------------------------------------------------------------------*;
;*    oproep         : DEBUG                                          *;
;**********************************************************************;

opttekst        .db 31,68,12,"Spc: Toggle"
                .db 31,68,13,"Esc: Quit"
                .db 28,1,22,78,15,16,26
                .db 31,28,15,"Atomic Debugger Options"
                .db 31,22,17,"ROM debuggin' :"
                .db 0

statusopt       .db "Options menu",0

opt             ldx #7
                ldy #6
                jsr scrcopy
                ldx #<opttekst
                ldy #>opttekst
                jsr showmenu
                ldx #<statusopt
                ldy #>statusopt
                jsr statusline

optmenu         ldx #38         ;cursor naar juiste positie
                ldy #17
                jsr gotoxy
                lda options     ;laadt optie byte
                bmi optmenu1
                jsr print       ;print melding optie enabled
                .db "enabled ",$EA
                jmp optmenu2    ;spring naar invoer
optmenu1        jsr print       ;print melding optie disabled
                .db "disabled",$EA
optmenu2        jsr rdch        ;lees toets
                cmp #32         ;test op spatie
                bne optmenu3
                lda options     ;toggle optie
                eor #$80
                sta options
                jmp optmenu     ;terug naar menu
optmenu3        cmp #27         ;escape?
                bne optmenu2    ;spring indien ongeldige toets

opt_end         ldx #6
                ldy #7
                jsr scrcopy
                rts
