/* File: icerout.h
contains functions for ice16f84 */

int xtoi(char *hex)
	{
	int d=0, n=0;
	while (d<strlen(hex))
		{
		if (isxdigit(hex[d]))
			{
			if (isdigit(hex[d]))
				{
				n=n*16+hex[d]-'0';
				}
			else
				{
				n=n*16+hex[d]-'A'+10;
				}
			}
		d++;
		}
	return n;
	}

int readhex(int digits)
	{
	int i=0, c=0;
	char h[8];
	while (c!=enter)
		{
		c=readkey();
		if (isxdigit(c) && i<digits)
			{
			h[i++]=c;
			cprintf("%c", c);
			}
		if ((c==key_bs || c==key_delete) && i>0)
			{
			i--;
			cprintf("%c %c", 0x08, 0x08);
			}
		}
	h[i]=0x00;
	if (i)
		return xtoi(h);
	else
		return -1;
	}

void breakpointsubwindow(void)
	{
        int i,j;
        gotoxy(40,16);
        _textattr(BG_CYAN);
        for (i=0; i<35; i++)
                cprintf(" ");
        for (j=0; j<6; j++)
                {
                gotoxy(40,j+17);
                cprintf(" ");
                _textattr(NORMAL);
                for (i=0; i<33; i++)
                        cprintf(" ");
                _textattr(BG_CYAN);
                cprintf(" ");
                }
	gotoxy(40,23);
        for (i=0; i<35; i++)
                cprintf(" ");
        gotoxy(42,17);
        _textattr(NORMAL);
	}	

void breakpointmenu(void)
	{
	int bp=-1, addr=-1, c=0, save;
	save=current_view_window;
	while(toupper(c) != key_q)
		{
		if (c!=-1)
			{
			showbreakpoints();
			showdisas(first_disas_address);
			breakpointsubwindow();
			cprintf("Enter command:");
			gotoxy(42,19);
			cprintf("'s' = set breakpoint");
			gotoxy(42,20);
			cprintf("'c' = clear breakpoint");
			gotoxy(42,21);
			cprintf("'a' = clear all breakpoints");
			gotoxy(42,22);
			cprintf("'q' = quit breakpoint menu");
			}
		c=readkey();
		switch(toupper(c))
			{
			case key_s:
				{
				breakpointsubwindow();
				gotoxy(45,20);
				cprintf("Which breakpoint ? ");
				bp=readhex(1);
				gotoxy(45,21);
				cprintf("at address ? ");
				addr=readhex(4);
				if(bp>-1 && bp<8)
					breakpoint[bp]=addr&0x3FF;
				break;
				}
			case key_c:
				{
				breakpointsubwindow();
				gotoxy(45,20);
				cprintf("Clear which breakpoint ? ");
				bp=readhex(1);
				if(bp>-1 && bp<8)
					breakpoint[bp]=0xFFFF;
				break;
				}
			case key_a:
				{
				for(bp=0; bp<7; bp++)
					breakpoint[bp]=0xFFFF;
				break;
				}
			case key_q:
				{
				current_view_window=save;
				update_view_window();
				break;
				}
			}
		}
	}
