/* ICE16F84 screen routines */

#define W_SHOWFILE	0
#define W_available	1
#define W_STACK		2
#define W_EEPROM	3
#define W_BREAKPOINTS	4
#define W_CONFIG	5

#define S_RUNNING	1
#define S_READY		2
#define S_WAITING	3
#define S_INPUT		4
#define S_ERROR		5

char version[]="Version 0.00, build 0000011017";
int first_disas_address=0;
int current_view_window=0;

void buildscreen(char *title)
	{
	int i,j;
	char kaderdef[] = { 1,1,201,30,205,1,203,28,205,1,203,18,205,1,187,
			   12,1,186,30, 32,1,186,28, 32,1,186,18, 32,1,186,
			    1,1,204,30,205,1,202,28,205,1,202,18,205,1,185,
			    8,1,186,30, 32,1, 32,28, 32,1, 32,18, 32,1,186,
			    1,1,200,30,205,1,205,28,205,1,205,18,205,1,188,
			    0};

	_textattr(BG_RED);
	clrscr();
	_textattr(NORMAL);
	_textattr(BG_BLUE);
	_textattr(WHITE);
	cprintf(" %s", title);
	i=strlen(title);
	while(i++<79) cprintf(" ");
	_textattr(BG_BLACK);
	_textattr(YELLOW);
	j=0;
	while (kaderdef[j])
		{
		int r,c,n;
		for(r=0; r<kaderdef[j]; r++)
			{
			for(n=0; n<7; n++)
				{
				c=kaderdef[1+j+n*2];
				while(c)
					{
				/*	cprintf("%c", kaderdef[2+j+n*2]);
					kaderdef[2+j+n*2]==32 ? cprintf (" ") : cprintf("%c", 219); */
					kaderdef[2+j+n*2]==32 ? _textattr(BG_BLACK) : _textattr(BG_BROWN);
					cprintf(" ");
					c--;
					}
				}
/*			cprintf("\n\r"); */
			}
		j+=15;
		}
	_textattr(BG_RED);
	_textattr(WHITE);
	cprintf(" PIC16F84 In-Circuit Emulator                             (c) Roland Leurs 2000");
	_textattr(NORMAL);
	}

void showdisas(int start)
	{
	int b,i,x,y;
	x=y=3;
	first_disas_address = start&0x03FF;
	for(i=first_disas_address; i<first_disas_address+12; i++)
		{
		for(b=0; b<8; b++)
			if ((i&0x03FF)==breakpoint[b]) _textattr(MAGENTA);
		if ((i&0x03FF)==pc) _textattr(GREEN);
		showinstr(i,x,y++);	/* show instruction at address i */
		_textattr(NORMAL);
		}
	}

void showregs(void)
	{
	int x,y;
	x=34;
	y=3;
	gotoxy(x,y++);
	cprintf("W       : %0.2X  INTCON  : %0.2X", w, regfile[INTCON]);
	gotoxy(x,y++);
	cprintf("TMR0    : %0.2X  OPTION  : %0.2X", regfile[TMR0], regfile[OPTION]);
        gotoxy(x,y++);
	cprintf("PCL     : %0.2X  PCLATH  : %0.2X", regfile[PCL], regfile[PCLATH]);
        gotoxy(x,y++);
	cprintf("FSR     : %0.2X  Ind.addr: %0.2X", regfile[FSR], regfile[INDIR]);
        gotoxy(x,y++);
	cprintf("PORTA   : %0.2X  TRISA   : %0.2X", porta('r',0), regfile[TRISA]);
        gotoxy(x,y++);
	cprintf("PORTB   : %0.2X  TRISB   : %0.2X", portb('r',0), regfile[TRISB]);
	gotoxy(x,y++);
	cprintf("EEDATA  : %0.2X  EECON1  : %0.2X", regfile[EEDATA], regfile[EECON1]);
        gotoxy(x,y);
	y+=2;
	cprintf("EEADR   : %0.2X  EECON2  : %0.2X", regfile[EEADR], regfile[EECON2]);
        gotoxy(x,y++);
	cprintf("STATUS  : %0.2X", regfile[STATUS]);
	gotoxy(x,y++);
	cprintf("IRP RP1 RP0 -TO -PD Z DC C");
	gotoxy(x,y++);
	regfile[STATUS] & 0x80 ? cprintf("  1 ") : cprintf("  0 ");
	regfile[STATUS] & 0X40 ? cprintf("  1 ") : cprintf("  0 ");
	regfile[STATUS] & 0x20 ? cprintf("  1 ") : cprintf("  0 ");
	regfile[STATUS] & 0x10 ? cprintf("  1 ") : cprintf("  0 ");
	regfile[STATUS] & 0x08 ? cprintf("  1 ") : cprintf("  0 ");
	regfile[STATUS] & 0x04 ? cprintf("1 ") : cprintf("0 ");
	regfile[STATUS] & 0x02 ? cprintf(" 1 ") : cprintf(" 0 ");
	regfile[STATUS] & 0x01 ? cprintf("1") : cprintf("0");
	}

void clearshowwindow(void)
	{
	int i;
	for(i=16; i<24; i++)
		{
                gotoxy(2,i);
		cprintf("                                       "
                       "                                       ");
		}
	}

void showstack(void)
	{
	int i;
	current_view_window=W_STACK;
	clearshowwindow();
	for(i=0; i<8; i++)
		{
		gotoxy(3,16+i);
		if (i==0) cprintf("Top of stack:     ");
		if (i==7) cprintf("Bottom of stack:  ");
		if (i!=0 && i!=7) cprintf("                  ");
		cprintf("%0.4X: %0.4X", i, stack[i]);
		if (i==sp) cprintf("  <-- stack pointer");
		}
	}

void showfile(void)
	{
	int i,j,y=17,save;
	current_view_window = W_SHOWFILE;
	clearshowwindow();
	gotoxy(3,16);
	_textattr(CYAN);
	cprintf("SFR bank 0 and GPR's:");
	_textattr(WHITE);
	save=regfile[STATUS];
	regfile[STATUS]&=0xDF;
	for(i=0x00; i<0x4F; i+=16)
		{
                gotoxy(3,y++);
		cprintf("%0.4X: ", i);
		for(j=0; j<16; j++)
			{
			if (i+j==INDIR)
				cprintf("%0.2X ", regfile[INDIR]);
			else
				if (i+j==STATUS)
					cprintf("%0.2X ", save);
				else 
					cprintf("%0.2X ", getreg(i+j));
			if (j==7) cprintf("- ");
			}
		cprintf ("   ");
                for(j=0; j<16; j++)
                        {
			if (i+j==INDIR) 
				{
				if (isprint(regfile[INDIR]))
					cprintf("%c", regfile[INDIR]);
				else 
					cprintf(".");
				}
			else
				{
				if ((isprint(getreg(i+j)) && i!=STATUS) || (isprint(save) && i==STATUS)) 
					{
	                        	if (i+j==STATUS)
						cprintf("%c", save);
					else
						cprintf("%c", getreg(i+j));
					}
				else 
					cprintf(".");
				}
                        }
		}
	gotoxy(3,y++);
	_textattr(CYAN);
	cprintf("SFR bank 1:");
	_textattr(WHITE);
	gotoxy(3,y++);
	cprintf("0000: %0.2X ", regfile[INDIR]);
	regfile[STATUS]|=0x20;
        for(i=0x01; i<0x0C; i++)
                {
		i==STATUS ? cprintf("%0.2X ", save) : cprintf("%0.2X ", getreg(i));
		if (i==7) cprintf("- ");
                }
	cprintf("               ");
	if (isprint(regfile[INDIR]))
		cprintf("%c", regfile[INDIR]);
	else
		cprintf(".");
        for(i=0x01; i<0x0C; i++)
                {
                if ((isprint(getreg(i)) && i!=STATUS) || (isprint(save) && i==STATUS))
			i==STATUS ? cprintf("%c", save) : cprintf("%c", getreg(i));
                else
			cprintf(".");
                }
	regfile[STATUS]=save;
	}

void showbreakpoints(void)
	{
	int i;
	current_view_window=W_BREAKPOINTS;
	clearshowwindow();
	for(i=0; i<8; i++)
		{
                gotoxy(3,16+i);
		cprintf("Bp %d: ", i);
		if (breakpoint[i] != 0xFFFF)
			cprintf("%0.4X", breakpoint[i]);
		else cprintf("Breakpoint not set");
		}
	gotoxy(40,19);
	_textattr(CYAN);
	cprintf("Press 's' to enter the");
	gotoxy(40,20);
	cprintf("breakpoint submenu");
	_textattr(NORMAL);
	}

void showeeprom(void)
	{
	int i,j,y=18;
	current_view_window=W_EEPROM;
	clearshowwindow();
	gotoxy(3,16);
	cprintf("E-Eprom data view:");
	for(i=0; i<0x3F; i+=16)
		{
                gotoxy(3,y++);
		cprintf("%0.4X: ", i);
		for(j=0; j<16; j++)
			{
			cprintf("%0.2X ", eeprom[i+j]);
			if (j==7) cprintf("- ");
			}
		cprintf ("   ");
                for(j=0; j<16; j++)
                        {
			if (isprint(eeprom[i+j]))
				cprintf("%c", eeprom[i+j]);
			else cprintf(".");
                       }
		}
	}

void showconfig(void)
	{
	current_view_window=W_CONFIG;
	clearshowwindow();
	gotoxy(3,16);
	cprintf("Configuration word = %0.4X, meaning:", config);
	gotoxy(5,18);
	cprintf("Code protection bit:  ");
	config&0x3FF0 ? cprintf("off") : cprintf("on");
	gotoxy(5,19);
	cprintf("Power up Timer:       ");
	config&0x0008 ? cprintf("disabled") : cprintf("enabled");
	gotoxy(5,20);
	cprintf("Watchdog Timer:       ");
	config&0x0004 ? cprintf("enabled") : cprintf("disabled");
	gotoxy(5,21);
	cprintf("Oscillator Selection: ");
	if((config&0x03)==0x03) cprintf("RC");
	if((config&0x03)==0x02) cprintf("HS");
	if((config&0x03)==0x01) cprintf("XT");
	if((config&0x03)==0x00) cprintf("LP");
	cprintf(" Oscillator");
	}

void showkeyinfo(void)
	{
	_textattr(CYAN);
	gotoxy(63,3);
	cprintf("1  - show bank 0");
	gotoxy(63,4);
	cprintf("2  - show stack");
	gotoxy(63,5);
	cprintf("3  - show eeprom");
	gotoxy(63,6);
	cprintf("0  - breakpoints");
	gotoxy(63,8);
	cprintf("PgUp  - disas up");
	gotoxy(63,9);
	cprintf("PgDn  - disas dn");
	gotoxy(63,10);
	cprintf("Space - trace");
	gotoxy(63,11);
	cprintf("Enter - step");
	gotoxy(63,13);
	cprintf("H - Help");
	gotoxy(63,14);
	cprintf("Q - Quit");
	_textattr(NORMAL);
	}
	
void update_view_window(void)
	{
	switch (current_view_window)
		{
	case W_SHOWFILE:
		{
		showfile();
		break;
		}
        case W_STACK: 
                { 
                showstack();
                break;
                }
        case W_EEPROM: 
                { 
                showeeprom();
                break;
                }
        case W_BREAKPOINTS:
		{
                showbreakpoints();
                break;
                }
	case W_CONFIG:
		{
		showconfig();
		break;
		}
	}
	}

int runmsg(void)
	{
	clearshowwindow();
	gotoxy(15,20);
	_textattr(RED);
	cprintf("Free running mode: press <space> or <enter> to interrupt");
	gotoxy(15,21);
	cprintf("Executing instruction at address 0x");
	return 2;
	}

void showhelp(void)
	{
	clearshowwindow();
	gotoxy(3,16);
	_textattr(CYAN);
	cprintf("ICE 16F84 %s for %s, (c) Roland Leurs", version, platform);
	_textattr(WHITE);
	gotoxy(3,18);
	cprintf("Press '1' to view the register file");
	gotoxy(3,19);
	cprintf("Press '2' to view the stack");
	gotoxy(3,20);
	cprintf("Press '3' to view the E-eprom contents");
	gotoxy(3,21);
	cprintf("Press '9' to examine the CONFIG bits");
	gotoxy(3,22);
	cprintf("Press '0' for the breakpoint menu");
	gotoxy(49,23);
	cprintf("Press 'h' for more information");
	while (toupper(readkey()) != 'H') ;
        clearshowwindow();
        gotoxy(3,16);
        _textattr(CYAN);
	cprintf("ICE 16F84 %s", version);
        _textattr(WHITE);
	gotoxy(3,18);
	cprintf("Press 'PgUp' for the previous page of the disas listing");
        gotoxy(3,19);
	cprintf("Press 'PgDn' for the next page of the disas listing");
        gotoxy(3,20);
	cprintf("Press 'Enter' to execute the instruction at current PC location");
        gotoxy(3,21);
	cprintf("Press 'Space' to execute the current intstruction,");
	gotoxy(17,22);
	cprintf("subroutine will be treated as one single instruction");
        gotoxy(52,23);
	cprintf("Press 'h' to quit this help");
	while (toupper(readkey()) != 'H') ;
	update_view_window();
	}

void showstatus(int status)
	{
	gotoxy(72,1);
	status==S_ERROR ? _textattr(BG_RED) : _textattr(BG_GREEN);
	_textattr(WHITE);
	switch (status)
		{
		case S_RUNNING:
			{
			cprintf("Running");
			break;
			}
		case S_WAITING:
			{
			cprintf("Waiting");
			break;
			}
		case S_READY:
			{
			cprintf(" Ready ");
			break;
			}
		case S_INPUT:
			{
			cprintf(" Input ");
			break;
			}
		case S_ERROR:
			{
			cprintf(" Error ");
			break;
			}
		}
	_textattr(NORMAL);
	}
